package dev.shadowsoffire.apotheosis.adventure.client;

import org.apache.commons.lang3.mutable.MutableInt;
import net.minecraftforge.network.NetworkDirection;
import java.util.Optional;
import dev.shadowsoffire.placebo.network.MessageHelper;
import net.minecraftforge.network.NetworkEvent;
import java.util.function.Supplier;
import net.minecraft.network.FriendlyByteBuf;
import dev.shadowsoffire.placebo.network.MessageProvider;
import net.minecraft.core.BlockPos;

public class BossSpawnMessage
{
    private final BlockPos pos;
    private final int color;
    
    public BossSpawnMessage(final BlockPos pos, final int color) {
        this.pos = pos;
        this.color = color;
    }
    
    public static class Provider implements MessageProvider<BossSpawnMessage>
    {
        public Class<?> getMsgClass() {
            return BossSpawnMessage.class;
        }
        
        public void write(final BossSpawnMessage msg, final FriendlyByteBuf buf) {
            buf.m_130064_(msg.pos);
            buf.writeInt(msg.color);
        }
        
        public BossSpawnMessage read(final FriendlyByteBuf buf) {
            return new BossSpawnMessage(buf.m_130135_(), buf.readInt());
        }
        
        public void handle(final BossSpawnMessage msg, final Supplier<NetworkEvent.Context> ctx) {
            MessageHelper.handlePacket(() -> AdventureModuleClient.onBossSpawn(msg.pos, toFloats(msg.color)), (Supplier)ctx);
        }
        
        public Optional<NetworkDirection> getNetworkDirection() {
            return Optional.of(NetworkDirection.PLAY_TO_CLIENT);
        }
        
        private static float[] toFloats(final int color) {
            final float[] arr = { (color >> 16 & 0xFF) / 255.0f, (color >> 8 & 0xFF) / 255.0f, (color & 0xFF) / 255.0f };
            return arr;
        }
    }
    
    record BossSpawnData(BlockPos pos, float[] color, MutableInt ticks) {}
}
